; '2600 for Newbies
; Session 21 - Sprites
; This kernel draws a simple box around the screen border
; Introduces sprites


                processor 6502
                include "vcs.h"
                include "macro.h"

SpriteHeight	= 8

                SEG.U vars
                ORG $80

SpriteXPosition ds 1
PlayerX         ds 2             ; x coordinate
PS_temp		ds 1
Sprite		ds 2
SpriteEnd	ds 1


Pot0		ds 1 ;paddle value
Pot1		ds 1


PBuffer		ds 1




;------------------------------------------------------------------------------

                SEG code
                ORG $F000

Reset

    ; Clear RAM and all TIA registers

                ldx #0 
                lda #0 
Clear           sta 0,x 
                inx 
                bne Clear

                ldx #$FF
                txs

        ;------------------------------------------------
        ; Once-only initialisation...

                lda #$45
                sta COLUPF              ; set the playfield colour
                
                lda #$56
                sta COLUP0
                lda #$67
                sta COLUP1

                lda #%00000001
                sta CTRLPF              ; reflect playfield
                lda #80
                sta PlayerX+1

		lda #60
		sta SpriteEnd

		lda #<Sprite0Data
    		sta Sprite
    		lda #>Sprite0Data
    		sta Sprite+1 
		
		lda #75
		sta PlayerX
		
		lda #192/2
		sta SpriteEnd
		
		
		
		
        ;------------------------------------------------

StartOfFrame

    ; Start of new frame
    ; Start of vertical blank processing

                lda #$82 ; VB_DumpPots & VB_Enable (Thanks Eckhard!)
                ;lda #00
                sta VBLANK

                lda #2
                sta VSYNC

                sta WSYNC
                sta WSYNC
                sta WSYNC                ; 3 scanlines of VSYNC signal

                lda #0
                sta VSYNC
                LDA  #$2
        	STA  VBLANK  ; Start recharge of paddle capacitor
                
        ;------------------------------------------------
        ; 37 scanlines of vertical blank...
            
                ldx #0
VerticalBlank   sta WSYNC
                inx
                cpx #36
                bne VerticalBlank
  		
  		lda #0
  		sta VBLANK
  		sta WSYNC

                ;ldy #192                  ; this counts our scanline number
		ldx #192
                lda #%00000000          ; PF0 is mirrored <--- direction, low 4 bits ignored
                sta PF0
                lda #0
                sta PF1
                sta PF2

                    ; again, we don't bother writing PF0-PF2 every scanline - they never change!

                sta WSYNC

MiddleLines     
                TXA; transfer scanline count to A
 		SEC                     ; well for this example I don't know the state
      		SBC SpriteEnd           ; so that's 96 - 96 = 0
		adc #SpriteHeight 	; remember the sprite is 8 lines high
		bcc .skipMBDraw3           ; out of range???
		tay
		lda (Sprite),y   ; use indirect loading here
		sta PBuffer
		
		;----------------------------------
		; WHY DON'T YOU WORK!
        	;sec                     ; 2  can often be guaranteed, and omitted

         	;tya                     ; 2
        	;sbc SpriteEnd           ; 3
        	;adc #SpriteHeight      ; 2
        	;bcs .MBDraw3            ; 2(3)

        	;nop                     ; 2
        	;nop                     ; 2
        	;sec                     ; 2
        	;bcs .skipMBDraw3          ; 3

;.MBDraw3
		;tay
        	;lda (Sprite),Y          ; 5
        	;sta GRP0       ; 3
        	;-----------------------------------

.skipMBDraw3 
		LDA  INPT0              ; Read paddle 0
		BMI  Charged            ; Capacitor already charged, skip increment
		INC  Pot0               ; Increment paddle position value
Charged
		LDA INPT1
		BMI Charged2
		INC Pot1
Charged2
                sta WSYNC
                lda PBuffer
                sta GRP0
                ;inx
                ;dey
		dex
		bne MiddleLines

                lda #0
                sta GRP0
                sta GRP1

 
                lda #%01000010
                sta VBLANK           ; end of screen - enter blanking

    ; 30 scanlines of overscan...

                ldy #0
		sty PF0
		sty PF1
		sty PF2
Overscan        sta WSYNC
                iny
                cpy #22
                bne Overscan
                
	ldx Pot0
	cpx #150
	bcc NoMod
	;jmp NoMod
NoBott	ldx #150
NoMod
	stx PlayerX
	ldx #1
	stx Pot0
	
	ldx Pot1
	cpx #9
	bcc NoBott2
	jmp NoMod2
NoBott2 
	ldx #9
NoMod2	stx SpriteEnd
	ldx #1
	stx Pot1
;Not the most effecient code, but gets the job done,
;including diagonal movement
;

; for up and down, we INC or DEC
; the Y Position
;
;	LDA #%00010000	;Down?
;	BIT SWCHA 
;	BNE SkipMoveDown
;	ldx SpriteEnd
;	cpx #192
;	beq SkipMoveUp
;	INC SpriteEnd
;	;inc UpPressed
;SkipMoveDown
;
;	LDA #%00100000	;Up?
;	BIT SWCHA 
;	BNE SkipMoveUp
;	ldx SpriteEnd
;	cpx #9
;	beq SkipMoveUp
;	DEC SpriteEnd
;	;inc DownPressed
;SkipMoveUp

; for left and right, we're gonna 
; set the horizontal speed, and then do
; a single HMOVE.  We'll use X to hold the
; horizontal speed, then store it in the 
; appropriate register


;assum horiz speed will be zero
;	LDX #0	
;
;	LDA #%01000000	;Left?
;	BIT SWCHA 
;	BNE SkipMoveLeft
;	ldx PlayerX
;	cpx #1
;	beq SkipMoveRight
;	dec PlayerX	;a 1 in the left nibble means go left
;	;inc LeftPressed
;SkipMoveLeft
;
;	LDA #%10000000	;Right?
;	BIT SWCHA 
;	BNE SkipMoveRight
;	ldx PlayerX
;	cpx #150
;	beq SkipMoveRight
;	inc PlayerX	;a -1 in the left nibble means go right...
;	;inc RightPressed
;SkipMoveRight
;			;(in 4 bits, using "two's complement 
			; notation", binary 1111 = decimal -1
			; (which we write there as hex F --
			; confused?))


	;STX HMM0	;set the move for missile 0


; while we're at it, change the color of the background
; if the button is pressed (making sure D6 of VBLANK has
; appropriately set above) We'll set the background color
; to the vertical position, since that will be changing 
; a lot but we can still control it.

	LDA INPT4		;read button input
	BMI ButtonNotPressed	;skip if button not pressed
	LDA SpriteEnd		;must be pressed, get YPos
	STA COLUP0		;load into bgcolor
ButtonNotPressed

;		inc SpriteEnd
;		ldx UpPressed
;		beq NoUp
;		ldx SpriteEnd
;		cpx #192
;		bcc LT192
;		ldx #192
;		stx SpriteEnd
;		jmp NoDown	
;LT192
;NoUp
;		ldx DownPressed
;		beq NoDown
;		ldx SpriteEnd
;		bne GT0X
;		ldx #0
;		stx SpriteEnd
;		
;		; Now adjust the sprite position
;		
;;		ldx PlayerX
;;		bne GT0
;;		ldx #0
;;		stx PlayerX
;;
;;				
;GT0X
;NoDown
;;
;		ldx RightPressed
;		beq NoRight
;		ldx PlayerX
;		cpx #150
;		bcc LT150
;		ldx #150
;		stx PlayerX
;		jmp NoLeft
;		
;LT150
;NoRight
;		ldx LeftPressed
;		beq NoLeft
;		ldx PlayerX
;		bne GT0Y
;		ldx #0
;		stx SpriteEnd
;		
;NoLeft
;GT0Y

                jsr PositionSprites

                jmp StartOfFrame



PositionSprites

        ; Set the horizontal position of the two sprites, based upon their coordinates
        ; This uses the tricky 2600 method of positioning (RESPx, HMPx, etc)

        ; Algorithm invented a looong time ago by persons unknown
        ; Re-invented Feb2001 by yours truly, then optimised according to code by Thomas Jenztsch

        sta WSYNC
        sta HMCLR                       ; clear any previous movement

        ldx #2                          ; sprite index
PosSP   
        lda PlayerX-1,x

        tay

        lsr
        lsr
        lsr
        lsr
        
        sta PS_temp

        tya
        and #15

        clc
        adc PS_temp

        ldy PS_temp

        cmp #15
        bcc NH
        sbc #15
        iny
NH

                ; Use remainder for fine adjustment
        eor #7
        asl
        asl
        asl
        asl

        sta HMP0-1,x                      ; fine movement
        sta WSYNC

        jsr Ret
        bit 0                           ; 15 cycles = 3 loops :)

Jiggle  dey
        bpl Jiggle

        sta RESP0-1,x

        dex
        bne PosSP

        sta WSYNC
        sta HMOVE
        sta WSYNC
        rts

Ret
	rts


Sprite0Data
	.byte #%00000000
	.byte #%01000100
	.byte #%00101000
	.byte #%00010000
	.byte #%01111100
	.byte #%10010010
	.byte #%00011000
        .byte #%00011000
	.byte #%00000000


;------------------------------------------------------------------------------

            ORG $FFFA

InterruptVectors

            .word Reset           ; NMI
            .word Reset           ; RESET
            .word Reset           ; IRQ

    		END

